Index: trunk/NEMOGCM/NEMO/OPA_SRC/DYN/divcur.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/DYN/divcur.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/DYN/divcur.F90	(revision 2528)
@@ -4,4 +4,18 @@
    !! Ocean diagnostic variable : horizontal divergence and relative vorticity
    !!==============================================================================
+   !! History :  OPA  ! 1987-06  (P. Andrich, D. L Hostis)  Original code
+   !!            4.0  ! 1991-11  (G. Madec)
+   !!            6.0  ! 1993-03  (M. Guyon)  symetrical conditions
+   !!            7.0  ! 1996-01  (G. Madec)  s-coordinates
+   !!            8.0  ! 1997-06  (G. Madec)  lateral boundary cond., lbc
+   !!            8.1  ! 1997-08  (J.M. Molines)  Open boundaries
+   !!            8.2  ! 2000-03  (G. Madec)  no slip accurate
+   !!  NEMO      1.0  ! 2002-09  (G. Madec, E. Durand)  Free form, F90
+   !!             -   ! 2005-01  (J. Chanut) Unstructured open boundaries
+   !!             -   ! 2003-08  (G. Madec)  merged of cur and div, free form, F90
+   !!             -   ! 2005-01  (J. Chanut, A. Sellar) unstructured open boundaries
+   !!            3.3  ! 2010-09  (D.Storkey and E.O'Dea) bug fixes for BDY module
+   !!             -   ! 2010-10  (R. Furner, G. Madec) runoff and cla added directly here
+   !!----------------------------------------------------------------------
 
    !!----------------------------------------------------------------------
@@ -9,10 +23,11 @@
    !!                vorticity fields
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and tracers
    USE dom_oce         ! ocean space and time domain
+   USE sbc_oce, ONLY : ln_rnf   ! surface boundary condition: ocean
+   USE sbcrnf          ! river runoff 
+   USE obc_oce         ! ocean lateral open boundary condition
+   USE cla             ! cross land advection             (cla_div routine)
    USE in_out_manager  ! I/O manager
-   USE obc_oce         ! ocean lateral open boundary condition
-   USE bdy_oce	       ! Unstructured open boundaries variables
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
 
@@ -20,6 +35,5 @@
    PRIVATE
 
-   !! * Accessibility
-   PUBLIC div_cur    ! routine called by step.F90 and istate.F90
+   PUBLIC   div_cur    ! routine called by step.F90 and istate.F90
 
    !! * Substitutions
@@ -27,9 +41,8 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -47,14 +60,11 @@
       !!      vorticity at before and now time-step
       !!
-      !! ** Method  : 
-      !!      I.  divergence :
+      !! ** Method  : I.  divergence :
       !!         - save the divergence computed at the previous time-step
       !!      (note that the Asselin filter has not been applied on hdivb)
       !!         - compute the now divergence given by :
       !!         hdivn = 1/(e1t*e2t*e3t) ( di[e2u*e3u un] + dj[e1v*e3v vn] )
-      !!      Note: if lk_zco=T, e3u=e3v=e3t, they are simplified in the
-      !!      above expression
-      !!         - apply lateral boundary conditions on hdivn 
-      !!      II. vorticity :
+      !!      correct hdiv with runoff inflow (div_rnf) and cross land flow (div_cla) 
+      !!              II. vorticity :
       !!         - save the curl computed at the previous time-step
       !!            rotb = rotn
@@ -62,6 +72,4 @@
       !!         - compute the now curl in tensorial formalism:
       !!            rotn = 1/(e1f*e2f) ( di[e2v vn] - dj[e1u un] )
-      !!         - apply lateral boundary conditions on rotn through a call
-      !!      of lbc_lnk routine.
       !!         - Coastal boundary condition: 'key_noslip_accurate' defined,
       !!      the no-slip boundary condition is computed using Schchepetkin
@@ -69,22 +77,15 @@
       !!      For example, along east coast, the one-sided finite difference
       !!      approximation used for di[v] is:
-      !!         di[e2v vn] =  1/(e1f*e2f)
-      !!                    * ( (e2v vn)(i) + (e2v vn)(i-1) + (e2v vn)(i-2) )
+      !!         di[e2v vn] =  1/(e1f*e2f) * ( (e2v vn)(i) + (e2v vn)(i-1) + (e2v vn)(i-2) )
       !!
       !! ** Action  : - update hdivb, hdivn, the before & now hor. divergence
       !!              - update rotb , rotn , the before & now rel. vorticity
-      !!
-      !! History :
-      !!   8.2  !  00-03  (G. Madec)  no slip accurate
-      !!   9.0  !  03-08  (G. Madec)  merged of cur and div, free form, F90
-      !!        !  05-01  (J. Chanut, A. Sellar) unstructured open boundaries
-      !!----------------------------------------------------------------------
-      !! * Arguments
+      !!----------------------------------------------------------------------
       INTEGER, INTENT( in ) ::   kt      ! ocean time-step index
-      
-      !! * Local declarations
+      !
       INTEGER ::   ji, jj, jk     ! dummy loop indices
       INTEGER ::   ii, ij, jl     ! temporary integer
       INTEGER ::   ijt, iju       ! temporary integer
+      REAL(wp) ::  zraur, zdep
       REAL(wp), DIMENSION(   jpi  ,1:jpj+2) ::   zwu   ! workspace
       REAL(wp), DIMENSION(-1:jpi+2,  jpj  ) ::   zwv   ! workspace
@@ -100,8 +101,8 @@
       DO jk = 1, jpkm1                                 ! Horizontal slab
          !                                             ! ===============
-
+         !
          hdivb(:,:,jk) = hdivn(:,:,jk)    ! time swap of div arrays
          rotb (:,:,jk) = rotn (:,:,jk)    ! time swap of rot arrays
-
+         !
          !                                             ! --------
          ! Horizontal divergence                       !   div
@@ -109,14 +110,8 @@
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
-#if defined key_zco
-               hdivn(ji,jj,jk) = (  e2u(ji,jj) * un(ji,jj,jk) - e2u(ji-1,jj  ) * un(ji-1,jj  ,jk)      &
-                  &               + e1v(ji,jj) * vn(ji,jj,jk) - e1v(ji  ,jj-1) * vn(ji  ,jj-1,jk)  )   &
-                  &            / ( e1t(ji,jj) * e2t(ji,jj) )
-#else
                hdivn(ji,jj,jk) =   &
                   (  e2u(ji,jj)*fse3u(ji,jj,jk) * un(ji,jj,jk) - e2u(ji-1,jj  )*fse3u(ji-1,jj  ,jk) * un(ji-1,jj  ,jk)       &
                    + e1v(ji,jj)*fse3v(ji,jj,jk) * vn(ji,jj,jk) - e1v(ji  ,jj-1)*fse3v(ji  ,jj-1,jk) * vn(ji  ,jj-1,jk)  )    &
                   / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
-#endif
             END DO
          END DO
@@ -131,12 +126,4 @@
             IF( lp_obc_south )   hdivn(nis0  :nis1  ,njs0  :njs1  ,jk) = 0.e0      ! south
          ENDIF
-#endif         
-#if defined key_bdy
-         ! unstructured open boundaries (div must be zero behind the open boundary)
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               hdivn(ji,jj,jk)=hdivn(ji,jj,jk)*bdytmask(ji,jj)
-            END DO
-         END DO
 #endif         
          IF( .NOT. AGRIF_Root() ) THEN
@@ -210,6 +197,5 @@
             DO ji = 1, fs_jpim1   ! vector opt.
                rotn(ji,jj,jk) = (  zwv(ji+1,jj  ) - zwv(ji,jj)      &
-                                 - zwu(ji  ,jj+1) + zwu(ji,jj)  )   &
-                              * fmask(ji,jj,jk) / ( e1f(ji,jj)*e2f(ji,jj) )
+                  &              - zwu(ji  ,jj+1) + zwu(ji,jj)  ) * fmask(ji,jj,jk) / ( e1f(ji,jj)*e2f(ji,jj) )
             END DO
          END DO
@@ -240,14 +226,15 @@
                * ( -4. * zwu(ii,ij) + zwu(ii,ij-1) - 0.2 * zwu(ii,ij-2) )
          END DO
-
          !                                             ! ===============
       END DO                                           !   End of slab
       !                                                ! ===============
+
+      IF( ln_rnf      )   CALL sbc_rnf_div( hdivn )          ! runoffs (update hdivn field)
+      IF( nn_cla == 1 )   CALL cla_div    ( kt )             ! Cross Land Advection (Update Hor. divergence)
       
       ! 4. Lateral boundary conditions on hdivn and rotn
       ! ---------------------------------=======---======
-      CALL lbc_lnk( hdivn, 'T', 1. )     ! T-point, no sign change
-      CALL lbc_lnk( rotn , 'F', 1. )     ! F-point, no sign change
-
+      CALL lbc_lnk( hdivn, 'T', 1. )   ;   CALL lbc_lnk( rotn , 'F', 1. )    ! lateral boundary cond. (no sign change)
+      !
    END SUBROUTINE div_cur
    
@@ -269,7 +256,5 @@
       !!      - compute the now divergence given by :
       !!         hdivn = 1/(e1t*e2t*e3t) ( di[e2u*e3u un] + dj[e1v*e3v vn] )
-      !!      Note: if lk_zco=T, e3u=e3v=e3t, they are simplified in the 
-      !!      above expression
-      !!      - apply lateral boundary conditions on hdivn 
+      !!      correct hdiv with runoff inflow (div_rnf) and cross land flow (div_cla) 
       !!              - Relavtive Vorticity :
       !!      - save the curl computed at the previous time-step (rotb = rotn)
@@ -277,6 +262,4 @@
       !!      - compute the now curl in tensorial formalism:
       !!            rotn = 1/(e1f*e2f) ( di[e2v vn] - dj[e1u un] )
-      !!      - apply lateral boundary conditions on rotn through a call to
-      !!      routine lbc_lnk routine.
       !!      Note: Coastal boundary condition: lateral friction set through
       !!      the value of fmask along the coast (see dommsk.F90) and shlat
@@ -285,20 +268,9 @@
       !! ** Action  : - update hdivb, hdivn, the before & now hor. divergence
       !!              - update rotb , rotn , the before & now rel. vorticity
-      !!
-      !! History :
-      !!   1.0  !  87-06  (P. Andrich, D. L Hostis)  Original code
-      !!   4.0  !  91-11  (G. Madec)
-      !!   6.0  !  93-03  (M. Guyon)  symetrical conditions
-      !!   7.0  !  96-01  (G. Madec)  s-coordinates
-      !!   8.0  !  97-06  (G. Madec)  lateral boundary cond., lbc
-      !!   8.1  !  97-08  (J.M. Molines)  Open boundaries
-      !!   9.0  !  02-09  (G. Madec, E. Durand)  Free form, F90
-      !!        !  05-01  (J. Chanut) Unstructured open boundaries
-      !!----------------------------------------------------------------------
-      !! * Arguments
+      !!----------------------------------------------------------------------
       INTEGER, INTENT( in ) ::   kt     ! ocean time-step index
-      
-      !! * Local declarations
+      !
       INTEGER  ::   ji, jj, jk          ! dummy loop indices
+      REAL(wp) ::  zraur, zdep
       !!----------------------------------------------------------------------
 
@@ -312,8 +284,8 @@
       DO jk = 1, jpkm1                                 ! Horizontal slab
          !                                             ! ===============
-
+         !
          hdivb(:,:,jk) = hdivn(:,:,jk)    ! time swap of div arrays
          rotb (:,:,jk) = rotn (:,:,jk)    ! time swap of rot arrays
-
+         !
          !                                             ! --------
          ! Horizontal divergence                       !   div 
@@ -321,14 +293,8 @@
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
-#if defined key_zco
-               hdivn(ji,jj,jk) = (  e2u(ji,jj) * un(ji,jj,jk) - e2u(ji-1,jj  ) * un(ji-1,jj  ,jk)      &
-                  &               + e1v(ji,jj) * vn(ji,jj,jk) - e1v(ji  ,jj-1) * vn(ji  ,jj-1,jk)  )   & 
-                  / ( e1t(ji,jj) * e2t(ji,jj) )
-#else
                hdivn(ji,jj,jk) =   &
-                  (  e2u(ji,jj)*fse3u(ji,jj,jk) * un(ji,jj,jk) - e2u(ji-1,jj  )*fse3u(ji-1,jj  ,jk) * un(ji-1,jj  ,jk)       &
-                   + e1v(ji,jj)*fse3v(ji,jj,jk) * vn(ji,jj,jk) - e1v(ji  ,jj-1)*fse3v(ji  ,jj-1,jk) * vn(ji  ,jj-1,jk)  )    &
+                  (  e2u(ji,jj)*fse3u(ji,jj,jk) * un(ji,jj,jk) - e2u(ji-1,jj)*fse3u(ji-1,jj,jk) * un(ji-1,jj,jk)       &
+                   + e1v(ji,jj)*fse3v(ji,jj,jk) * vn(ji,jj,jk) - e1v(ji,jj-1)*fse3v(ji,jj-1,jk) * vn(ji,jj-1,jk)  )    &
                   / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
-#endif
             END DO  
          END DO  
@@ -344,12 +310,4 @@
          ENDIF
 #endif         
-#if defined key_bdy
-         ! unstructured open boundaries (div must be zero behind the open boundary)
-         DO jj = 1, jpj
-           DO ji = 1, jpi
-             hdivn(ji,jj,jk)=hdivn(ji,jj,jk)*bdytmask(ji,jj)
-           END DO
-         END DO
-#endif        
          IF( .NOT. AGRIF_Root() ) THEN
             IF ((nbondi ==  1).OR.(nbondi == 2)) hdivn(nlci-1 , :     ,jk) = 0.e0      ! east
@@ -372,10 +330,12 @@
       END DO                                           !   End of slab
       !                                                ! ===============
-      
+
+      IF( ln_rnf      )   CALL sbc_rnf_div( hdivn )          ! runoffs (update hdivn field)
+      IF( nn_cla == 1 )   CALL cla_div    ( kt )             ! Cross Land Advection (update hdivn field)
+
       ! 4. Lateral boundary conditions on hdivn and rotn
       ! ---------------------------------=======---======
-      CALL lbc_lnk( hdivn, 'T', 1. )       ! T-point, no sign change
-      CALL lbc_lnk( rotn , 'F', 1. )       ! F-point, no sign change
-
+      CALL lbc_lnk( hdivn, 'T', 1. )   ;   CALL lbc_lnk( rotn , 'F', 1. )     ! lateral boundary cond. (no sign change)
+      !
    END SUBROUTINE div_cur
    
Index: trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynadv.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynadv.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynadv.F90	(revision 2528)
@@ -4,10 +4,11 @@
    !! Ocean active tracers:  advection scheme control
    !!==============================================================================
-   !! History :  9.0  !  06-11  (G. Madec)  Original code
+   !! History :  1.0  !  2006-11  (G. Madec)  Original code
+   !!            3.3  !  2010-10  (C. Ethe, G. Madec) reorganisation of initialisation phase
    !!----------------------------------------------------------------------
 
    !!----------------------------------------------------------------------
    !!   dyn_adv      : compute the momentum advection trend 
-   !!   dyn_adv_ctl  : control the different options of advection scheme
+   !!   dyn_adv_init : control the different options of advection scheme
    !!----------------------------------------------------------------------
    USE dom_oce         ! ocean space and time domain
@@ -22,9 +23,10 @@
    PRIVATE
 
-   PUBLIC dyn_adv     ! routine called by step module
+   PUBLIC dyn_adv       ! routine called by step module
+   PUBLIC dyn_adv_init  ! routine called by opa module
  
-   LOGICAL, PUBLIC ::   ln_dynadv_vec  = .TRUE.    ! vector form flag
-   LOGICAL, PUBLIC ::   ln_dynadv_cen2 = .FALSE.   ! flux form - 2nd order centered scheme flag
-   LOGICAL, PUBLIC ::   ln_dynadv_ubs  = .FALSE.   ! flux form - 3rd order UBS scheme flag
+   LOGICAL, PUBLIC ::   ln_dynadv_vec  = .TRUE.    !: vector form flag
+   LOGICAL, PUBLIC ::   ln_dynadv_cen2 = .FALSE.   !: flux form - 2nd order centered scheme flag
+   LOGICAL, PUBLIC ::   ln_dynadv_ubs  = .FALSE.   !: flux form - 3rd order UBS scheme flag
    
    INTEGER ::   nadv   ! choice of the formulation and scheme for the advection
@@ -34,7 +36,7 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2006) 
-   !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -56,6 +58,4 @@
       !!----------------------------------------------------------------------
       !
-      IF( kt == nit000 )   CALL dyn_adv_ctl          ! initialisation & control of options
-
       SELECT CASE ( nadv )                     ! compute advection trend and add it to general trend
       CASE ( 0 )     
@@ -77,7 +77,7 @@
 
    
-   SUBROUTINE dyn_adv_ctl
+   SUBROUTINE dyn_adv_init
       !!---------------------------------------------------------------------
-      !!                  ***  ROUTINE dyn_adv_ctl  ***
+      !!                  ***  ROUTINE dyn_adv_init  ***
       !!                
       !! ** Purpose :   Control the consistency between namelist options for 
@@ -85,5 +85,5 @@
       !!----------------------------------------------------------------------
       INTEGER ::   ioptio
-
+      !!
       NAMELIST/namdyn_adv/ ln_dynadv_vec, ln_dynadv_cen2 , ln_dynadv_ubs
       !!----------------------------------------------------------------------
@@ -94,5 +94,5 @@
       IF(lwp) THEN                    ! Namelist print
          WRITE(numout,*)
-         WRITE(numout,*) 'dyn_adv_ctl : choice/control of the momentum advection scheme'
+         WRITE(numout,*) 'dyn_adv_init : choice/control of the momentum advection scheme'
          WRITE(numout,*) '~~~~~~~~~~~'
          WRITE(numout,*) '       Namelist namdyn_adv : chose a advection formulation & scheme for momentum'
@@ -124,5 +124,5 @@
       ENDIF
       !
-   END SUBROUTINE dyn_adv_ctl
+   END SUBROUTINE dyn_adv_init
 
   !!======================================================================
Index: trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynadv_cen2.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynadv_cen2.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynadv_cen2.F90	(revision 2528)
@@ -31,5 +31,5 @@
    !! NEMO/OPA 3.2 , LODYC-IPSL  (2009)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt) 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynadv_ubs.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynadv_ubs.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynadv_ubs.F90	(revision 2528)
@@ -36,5 +36,5 @@
    !! NEMO/OPA 3.2 , LODYC-IPSL  (2009)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt) 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynbfr.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynbfr.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynbfr.F90	(revision 2528)
@@ -4,5 +4,5 @@
    !! Ocean dynamics :  bottom friction component of the momentum mixing trend
    !!==============================================================================
-   !! History :  9.0  !  2008-11  (A. C. Coward)  Original code
+   !! History :  3.2  ! 2008-11  (A. C. Coward)  Original code
    !!----------------------------------------------------------------------
 
@@ -13,5 +13,4 @@
    USE dom_oce         ! ocean space and time domain variables 
    USE zdf_oce         ! ocean vertical physics variables
-   USE zdfbfr          ! bottom friction
 
    USE trdmod          ! ocean active dynamics and tracers trends 
@@ -30,9 +29,8 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
-   !! $Id: dynzdf.F90 1152 2008-06-26 14:11:13Z rblod $
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
    
@@ -45,20 +43,18 @@
       !! ** Action  :   (ua,va)   momentum trend increased by bottom friction trend
       !!---------------------------------------------------------------------
-      USE oce, ONLY :   ztrdu => ta   ! use ta as 3D workspace
-      USE oce, ONLY :   ztrdv => sa   ! use sa as 3D workspace
+      USE oce, ONLY :   ztrduv => tsa   ! use tsa as 4D workspace
       !!
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
       !! 
-      INTEGER  ::   ji, jj          ! dummy loop indexes
-      INTEGER  ::   ikbu  , ikbv    ! temporary integers
-      INTEGER  ::   ikbum1, ikbvm1  !    -          -
-      REAL(wp) ::   zinv, zbfru, zbfrv   ! temporary scalar
+      INTEGER  ::   ji, jj       ! dummy loop indexes
+      INTEGER  ::   ikbu, ikbv   ! local integers
+      REAL(wp) ::   zm1_2dt      ! local scalar
       !!---------------------------------------------------------------------
       !
-      zinv = -1. / ( 2.*rdt )
+      zm1_2dt = - 1._wp / ( 2._wp * rdt )
 
       IF( l_trddyn )   THEN                      ! temporary save of ua and va trends
-         ztrdu(:,:,:) = ua(:,:,:)
-         ztrdv(:,:,:) = va(:,:,:)
+         ztrduv(:,:,:,1) = ua(:,:,:)
+         ztrduv(:,:,:,2) = va(:,:,:)
       ENDIF
 
@@ -70,16 +66,10 @@
          DO ji = 2, jpim1
 # endif
-            ikbu = MIN( mbathy(ji+1,jj), mbathy(ji,jj) )
-            ikbv = MIN( mbathy(ji,jj+1), mbathy(ji,jj) )
-            ikbum1 = MAX( ikbu-1, 1 )
-            ikbvm1 = MAX( ikbv-1, 1 )
+            ikbu = mbku(ji,jj)          ! deepest ocean u- & v-levels
+            ikbv = mbkv(ji,jj)
             !
-            ! Apply stability criteria on absolute value  : Min abs(bfr) => Max (bfr)
-            zbfru = MAX( bfrua(ji,jj), fse3u(ji,jj,ikbum1)*zinv )
-            zbfrv = MAX( bfrva(ji,jj), fse3v(ji,jj,ikbvm1)*zinv )
-            !
-            ua(ji,jj,ikbum1) = ua(ji,jj,ikbum1) + zbfru * ub(ji,jj,ikbum1) / fse3u(ji,jj,ikbum1)
-            va(ji,jj,ikbvm1) = va(ji,jj,ikbvm1) + zbfrv * vb(ji,jj,ikbvm1) / fse3v(ji,jj,ikbvm1)
-            !
+            ! Apply stability criteria on absolute value  : abs(bfr/e3) < 1/(2dt) => bfr/e3 > -1/(2dt)
+            ua(ji,jj,ikbu) = ua(ji,jj,ikbu) + MAX(  bfrua(ji,jj) / fse3u(ji,jj,ikbu) , zm1_2dt  ) * ub(ji,jj,ikbu)
+            va(ji,jj,ikbv) = va(ji,jj,ikbv) + MAX(  bfrua(ji,jj) / fse3v(ji,jj,ikbu) , zm1_2dt  ) * vb(ji,jj,ikbv)
          END DO
       END DO
@@ -87,7 +77,7 @@
       !
       IF( l_trddyn )   THEN                      ! save the vertical diffusive trends for further diagnostics
-         ztrdu(:,:,:) = ua(:,:,:) - ztrdu(:,:,:)
-         ztrdv(:,:,:) = va(:,:,:) - ztrdv(:,:,:)
-         CALL trd_mod( ztrdu, ztrdv, jpdyn_trd_bfr, 'DYN', kt )
+         ztrduv(:,:,:,1) = ua(:,:,:) - ztrduv(:,:,:,1)
+         ztrduv(:,:,:,2) = va(:,:,:) - ztrduv(:,:,:,2)
+         CALL trd_mod( ztrduv(:,:,:,1), ztrduv(:,:,:,2), jpdyn_trd_bfr, 'DYN', kt )
       ENDIF
       !                                          ! print mean trends (used for debugging)
